# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class ForwardingRule(pulumi.CustomResource):
    """
    A ForwardingRule resource. A ForwardingRule resource specifies which pool
    of target virtual machines to forward a packet to if it matches the given
    [IPAddress, IPProtocol, portRange] tuple.
    
    
    To get more information about ForwardingRule, see:
    
    * [API documentation](https://cloud.google.com/compute/docs/reference/latest/forwardingRule)
    * How-to Guides
        * [Official Documentation](https://cloud.google.com/compute/docs/load-balancing/network/forwarding-rules)
    
    <div class = "oics-button" style="float: right; margin: 0 0 -15px">
      <a href="https://console.cloud.google.com/cloudshell/open?cloudshell_git_repo=https%3A%2F%2Fgithub.com%2Fterraform-google-modules%2Fdocs-examples.git&cloudshell_working_dir=forwarding_rule_basic&cloudshell_image=gcr.io%2Fgraphite-cloud-shell-images%2Fterraform%3Alatest&open_in_editor=main.tf&cloudshell_print=.%2Fmotd&cloudshell_tutorial=.%2Ftutorial.md" target="_blank">
        <img alt="Open in Cloud Shell" src="//gstatic.com/cloudssh/images/open-btn.svg" style="max-height: 44px; margin: 32px auto; max-width: 100%;">
      </a>
    </div>
    """
    def __init__(__self__, __name__, __opts__=None, backend_service=None, description=None, ip_address=None, ip_protocol=None, ip_version=None, labels=None, load_balancing_scheme=None, name=None, network=None, network_tier=None, port_range=None, ports=None, project=None, region=None, service_label=None, subnetwork=None, target=None):
        """Create a ForwardingRule resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['backend_service'] = backend_service

        __props__['description'] = description

        __props__['ip_address'] = ip_address

        __props__['ip_protocol'] = ip_protocol

        __props__['ip_version'] = ip_version

        __props__['labels'] = labels

        __props__['load_balancing_scheme'] = load_balancing_scheme

        __props__['name'] = name

        __props__['network'] = network

        __props__['network_tier'] = network_tier

        __props__['port_range'] = port_range

        __props__['ports'] = ports

        __props__['project'] = project

        __props__['region'] = region

        __props__['service_label'] = service_label

        __props__['subnetwork'] = subnetwork

        __props__['target'] = target

        __props__['creation_timestamp'] = None
        __props__['label_fingerprint'] = None
        __props__['self_link'] = None
        __props__['service_name'] = None

        super(ForwardingRule, __self__).__init__(
            'gcp:compute/forwardingRule:ForwardingRule',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

