# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class GetInstanceGroupResult(object):
    """
    A collection of values returned by getInstanceGroup.
    """
    def __init__(__self__, description=None, instances=None, named_ports=None, network=None, project=None, self_link=None, size=None, zone=None, id=None):
        if description and not isinstance(description, str):
            raise TypeError('Expected argument description to be a str')
        __self__.description = description
        """
        Textual description of the instance group.
        """
        if instances and not isinstance(instances, list):
            raise TypeError('Expected argument instances to be a list')
        __self__.instances = instances
        """
        List of instances in the group.
        """
        if named_ports and not isinstance(named_ports, list):
            raise TypeError('Expected argument named_ports to be a list')
        __self__.named_ports = named_ports
        """
        List of named ports in the group.
        """
        if network and not isinstance(network, str):
            raise TypeError('Expected argument network to be a str')
        __self__.network = network
        """
        The URL of the network the instance group is in.
        """
        if project and not isinstance(project, str):
            raise TypeError('Expected argument project to be a str')
        __self__.project = project
        if self_link and not isinstance(self_link, str):
            raise TypeError('Expected argument self_link to be a str')
        __self__.self_link = self_link
        """
        The URI of the resource.
        """
        if size and not isinstance(size, int):
            raise TypeError('Expected argument size to be a int')
        __self__.size = size
        """
        The number of instances in the group.
        """
        if zone and not isinstance(zone, str):
            raise TypeError('Expected argument zone to be a str')
        __self__.zone = zone
        if id and not isinstance(id, str):
            raise TypeError('Expected argument id to be a str')
        __self__.id = id
        """
        id is the provider-assigned unique ID for this managed resource.
        """

async def get_instance_group(name=None, project=None, self_link=None, zone=None):
    """
    Get a Compute Instance Group within GCE.
    For more information, see [the official documentation](https://cloud.google.com/compute/docs/instance-groups/#unmanaged_instance_groups)
    and [API](https://cloud.google.com/compute/docs/reference/latest/instanceGroups)
    
    ```
    data "google_compute_instance_group" "all" {
    	name = "instance-group-name"
    	zone = "us-central1-a"
    }
    ```
    """
    __args__ = dict()

    __args__['name'] = name
    __args__['project'] = project
    __args__['selfLink'] = self_link
    __args__['zone'] = zone
    __ret__ = await pulumi.runtime.invoke('gcp:compute/getInstanceGroup:getInstanceGroup', __args__)

    return GetInstanceGroupResult(
        description=__ret__.get('description'),
        instances=__ret__.get('instances'),
        named_ports=__ret__.get('namedPorts'),
        network=__ret__.get('network'),
        project=__ret__.get('project'),
        self_link=__ret__.get('selfLink'),
        size=__ret__.get('size'),
        zone=__ret__.get('zone'),
        id=__ret__.get('id'))
