# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class TargetPool(pulumi.CustomResource):
    """
    Manages a Target Pool within GCE. This is a collection of instances used as
    target of a network load balancer (Forwarding Rule). For more information see
    [the official
    documentation](https://cloud.google.com/compute/docs/load-balancing/network/target-pools)
    and [API](https://cloud.google.com/compute/docs/reference/latest/targetPools).
    
    """
    def __init__(__self__, __name__, __opts__=None, backup_pool=None, description=None, failover_ratio=None, health_checks=None, instances=None, name=None, project=None, region=None, session_affinity=None):
        """Create a TargetPool resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['backup_pool'] = backup_pool

        __props__['description'] = description

        __props__['failover_ratio'] = failover_ratio

        __props__['health_checks'] = health_checks

        __props__['instances'] = instances

        __props__['name'] = name

        __props__['project'] = project

        __props__['region'] = region

        __props__['session_affinity'] = session_affinity

        __props__['self_link'] = None

        super(TargetPool, __self__).__init__(
            'gcp:compute/targetPool:TargetPool',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

