# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities, tables

class DatabaseInstance(pulumi.CustomResource):
    """
    Creates a new Google SQL Database Instance. For more information, see the [official documentation](https://cloud.google.com/sql/),
    or the [JSON API](https://cloud.google.com/sql/docs/admin-api/v1beta4/instances).
    
    > **NOTE on `google_sql_database_instance`:** - Second-generation instances include a
    default 'root'@'%' user with no password. This user will be deleted by Terraform on
    instance creation. You should use `google_sql_user` to define a custom user with
    a restricted host and strong password.
    """
    def __init__(__self__, __name__, __opts__=None, database_version=None, master_instance_name=None, name=None, project=None, region=None, replica_configuration=None, settings=None):
        """Create a DatabaseInstance resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['database_version'] = database_version

        __props__['master_instance_name'] = master_instance_name

        __props__['name'] = name

        __props__['project'] = project

        __props__['region'] = region

        __props__['replica_configuration'] = replica_configuration

        if not settings:
            raise TypeError('Missing required property settings')
        __props__['settings'] = settings

        __props__['connection_name'] = None
        __props__['first_ip_address'] = None
        __props__['ip_addresses'] = None
        __props__['self_link'] = None
        __props__['server_ca_cert'] = None
        __props__['service_account_email_address'] = None

        super(DatabaseInstance, __self__).__init__(
            'gcp:sql/databaseInstance:DatabaseInstance',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

